/*gm.cxx
  Yury P. Fedorchenko 2005-2009
*/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#include <Fl/Fl.H>
#include <Fl/Fl_Widget.H>
#include <Fl/Fl_Double_Window.H>
#include <Fl/Fl_Output.H>
#include <Fl/fl_draw.h>
#include <Fl/fl_ask.h>
#include <Fl/Fl_Pixmap.H>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "single.xpm"

#include "horiz.xpm"
#include "vert.xpm"
#include "shoots.xpm"


#include "gm.h"
#include "game.h"
#include "nls.h"
int dir_put;

static Fl_Pixmap *shd_pm = NULL;
static Fl_Pixmap *sh_pm = NULL;
static Fl_Pixmap *dth_pm = NULL;

extern Fl_Double_Window *mainWnd;
extern Fl_Output *status;

void gm_field::draw()
{
  int i, j;
  fl_color(0, 64, 128);
  fl_rectf(x(), y(), w(), h());
  fl_color(255, 64, 128);
  for (i = 0; i < 10; i++)
    for (j = 0; j < 10; j++) {
      switch (ship_dr[i][j]) {
      case 0:
        fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 1:
        if (type() == 1)
          fl_draw_pixmap(ship_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 3:
        if (type() == 1)
          fl_draw_pixmap(nos_v_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 4:
        if (type() == 1)
          fl_draw_pixmap(nos_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 5:
        if (type() == 1)
          fl_draw_pixmap(mid_v_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 6:
        if (type() == 1)
          fl_draw_pixmap(mid_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 7:
        if (type() == 1)
          fl_draw_pixmap(tail_v_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      case 8:
        if (type() == 1)
          fl_draw_pixmap(tail_xpm, f_x[i][j], f_y[i][j], fl_color_cube(0 * FL_NUM_RED / 256, 64 * FL_NUM_GREEN / 256, 128 * FL_NUM_BLUE / 256));
        else
          fl_rect(f_x[i][j], f_y[i][j], field_size, field_size);
        break;
      }                         //switch
      if (shoot[i][j] == 1) {
        if (ship[i][j] == 0)
          shd_pm->draw(f_x[i][j], f_y[i][j]);
        else
          sh_pm->draw(f_x[i][j], f_y[i][j]);
      } else if (level == 1)
        if (death[i][j] != 0 && ship_dr[i][j] == 0)
          dth_pm->draw(f_x[i][j], f_y[i][j]);
    }                           //for
}

int gm_field::handle(int e)
{
  if (active()) {
    struct pnt a;
    switch (e) {
    case FL_ENTER:
      if (type() == 1) {
        if (1 == dir_put)
          mainWnd->cursor(FL_CURSOR_WE);
        else
          mainWnd->cursor(FL_CURSOR_NS);
      } else
        mainWnd->cursor(FL_CURSOR_CROSS);
      return 1;
    case FL_LEAVE:
      mainWnd->cursor(FL_CURSOR_DEFAULT);
      return 1;
    case FL_PUSH:
      a.x = Fl::event_x();
      a.y = Fl::event_y();
      switch (Fl::event_button()) {
      case FL_LEFT_MOUSE:
        if (index(a) == 0) {
          //printf("ss %d ffss %d tp %d ns %d as %d\n",ship_size,first_field->ship_size,type_,game_netstate,already_shoot);
          if (type() == 1) {
            if (death[a.x][a.y] != 1) {
              if (setfield(this, a.x, a.y, (ship_size < 4) ? 4 : (ship_size < 10) ? 3 : (ship_size < 16) ? 2 : 1, dir_put))
                redraw();
              if (ship_size >= 20)
                init_battle();
            }
          } else if (gm_field::AI == game_netstate && type() == 2) {
            if (ship_size == 0 || first_field->ship_size == 0)
              return 0;
            if (shoot[a.x][a.y] != 1) {
              shoot[a.x][a.y] = 1;
              if (ship[a.x][a.y] != 0) {
                death_zone(a.x, a.y);
                ship_size--;
                status->value(_("Hit!"));
              } else {
                status->value(_("Miss!"));
                Battle(first_field);
              }
              if (ship_size == 0 || first_field->ship_size == 0)
                fl_message(_("game over %s"), (first_field->ship_size == 0) ? _("You Lose!") : _("You Win!"));
            }
          }
#ifdef HAVE_LIBGLOOX
          else {
            //printf("shoot[%d][%d]==%d\n",a.x,a.y,shoot[a.x][a.y]);
            if (gm_field::SEND == game_netstate && !already_shoot) {
              if (shoot[a.x][a.y] != 1) {
                char buf[124];
                sprintf(buf, "#MNW#%d:%d", a.x, a.y);
                shoot[a.x][a.y] = 1;
                net_pnt = a;
                //game_netstate=gm_field::WAIT;
                already_shoot = true;
                ses->send(buf);
              } else {
                //printf("shoot[%d][%d]==1\n",a.x,a.y);
              }
            }
          }
#endif
        }
        redraw();
        return 0;
      case FL_RIGHT_MOUSE:
        if (type() == 1) {
          dir_put = abs(dir_put - 1);
          if (1 == dir_put)
            mainWnd->cursor(FL_CURSOR_WE);
          else
            mainWnd->cursor(FL_CURSOR_NS);
        }
        return 0;
      }
      return 0;

    case FL_MOVE:
      a.x = Fl::event_x();
      a.y = Fl::event_y();
/*	if(index(a)==0)
	sprintf(str,"field %p, %d, %d!!!!",this,a.x,a.y);
	else
	sprintf(str,"field %p, %d, %d",this,Fl::event_x()-x(),Fl::event_y()-y());
	   status->value(str);*/
      return 0;
    }
  }
  return 0;
}

void gm_field::initialize()
{
  dir_put = 1;
  ship_size = 0;
  field_size = w() / 10;
  for (int i = 0; i < 10; ++i)
    for (int j = 0; j < 10; ++j) {
      f_x[i][j] = x() + i * field_size;
      f_y[i][j] = y() + j * field_size;
      ship[i][j] = 0;
      ship_dr[i][j] = 0;
      shoot[i][j] = 0;
      death[i][j] = 0;
    }
  if (!shd_pm)
    shd_pm = new Fl_Pixmap(shootd_xpm);
  if (!sh_pm)
    sh_pm = new Fl_Pixmap(shoot_xpm);
  if (!dth_pm)
    dth_pm = new Fl_Pixmap(dth_xpm);
}

int gm_field::hit(int i, int j)
{
  if (shoot[i][j] == 0) {
    if (ship[i][j] != 0)
      return ship[i][j];
    else
      return 0;
  } else {
    return -1;
  }
  return 0;
}

int gm_field::index(struct pnt &a)
{
  for (int i = 0; i < 10; ++i)
    for (int j = 0; j < 10; ++j) {
      if (f_x[i][j] < a.x && a.x < (f_x[i][j] + field_size) && f_y[i][j] < a.y && a.y < (f_y[i][j] + field_size)) {
        a.x = i;
        a.y = j;
        return 0;
      }
    }
  return -1;
}

void gm_field::death_zone(int i, int j)
{
  int k, l;
  k = i - 1;
  if (k >= 0) {
    l = j - 1;
    if (l >= 0)
      death[k][l] = 1;
    l = j + 1;
    if (l < FIELD_SIZE)
      death[k][l] = 1;
  }
  k = i + 1;
  if (k < FIELD_SIZE) {
    l = j - 1;
    if (l >= 0)
      death[k][l] = 1;
    l = j + 1;
    if (l < FIELD_SIZE)
      death[k][l] = 1;
  }
}

//end Death
