/*gm.h
  Yury P. Fedorchenko 2005-2009
*/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#include "config.h"

#if HAVE_LIBGLOOX
#include "gloox/messagesessionhandler.h"
#endif

struct pnt{int x;int y;};

#define FIELD_SIZE 10

class gm_field:public Fl_Widget{
    friend void Battle(gm_field* fld);
    friend void machine_init();
    friend int setfield(gm_field* fl, int x, int y,int size_put,int dir_put);
    int f_x[10][10];
    int f_y[10][10];
    int ship_dr[10][10];
    int death[10][10];
    int active_;
    int field_size;
public:
    int shoot[10][10];
    int ship[10][10];
    int ship_size;
    int type_;
    enum net_state{NONE=0,INVITE=1,ACCEPT=2,SEND=3,WAIT=4,AI=5} game_netstate;
#ifdef HAVE_LIBGLOOX
    gloox::MessageSession *ses;
    pnt net_pnt;
    bool already_shoot;
#endif
public:
    int level;//0,1(+fill_dz),2(+ran ubil),3(+razmer)
    int numb;
    void initialize();
    int hit(int i,int j);
    void death_zone(int,int);
    int index(struct pnt&);

    int type()const {return type_;}
    void type(int t){type_=t;}

    int active()const {return active_;}
    void set_active(int a=1){active_=a;}

    void draw();
    int handle(int e);

    gm_field(int tp,int X,int Y,int W):Fl_Widget(X,Y,W,W)
#ifdef HAVE_LIBGLOOX
    ,already_shoot(false)
#endif    
    {
    	active_=0;ship_size=0;level=0;game_netstate=NONE;
    	initialize();
    	type(tp);
    }
    void undeath(){for(int m=0;m<FIELD_SIZE;m++)for(int n=0;n<FIELD_SIZE;n++)death[m][n]=0;}

};
void Battle(gm_field* fld);

void new_cb(Fl_Widget*,long);

extern gm_field* first_field;
extern gm_field* second_field;
