/*intro.cxx
  Yury P. Fedorchenko 2005-2009
*/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#include <Fl/Fl.H>
#include <Fl/Fl_Double_Window.H>
#include <Fl/Fl_Box.H>
#include <Fl/Fl_Return_Button.H>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <locale.h>
#include "nls.h"

void exit_intr(void *p)
{
  Fl::handle(FL_CLOSE, (Fl_Window *) p);
}

#define cpr "%s%s%s",_("v "),VERSION,_("\n(c) Yury P. Fedorchenko 1998-2009\nhttp://www.fedorchenko.net")

void intro()
{
  Fl_Double_Window intrW(Fl::w() / 2 - 200, Fl::h() / 2 - 100, 420, 200, "Intro");
  intrW.border(0);
  intrW.color(FL_CYAN);
  intrW.box(FL_EMBOSSED_BOX);
  Fl_Box bx(10, 10, 400, 180, "flMan'O'waR");
  bx.color(FL_BLUE);
  bx.box(FL_ROUND_UP_BOX);
  bx.labelsize(60);
  bx.labeltype(FL_ENGRAVED_LABEL);
  bx.labelfont(FL_COURIER);

    static char verstr[1024];
    sprintf(verstr,cpr);
  Fl_Box bx2(140, 140, 150, 30, verstr);
  bx2.labelsize(18);

  intrW.add(&bx);
  intrW.add(&bx2);

  intrW.show();
  Fl::add_timeout(1.5, exit_intr, &intrW);
  while (intrW.visible())
    Fl::wait(0);
}

static void cb_ok_but(Fl_Widget * o, void *)
{
  ((Fl_Window *) (o->parent()))->hide();
}

#include <FL/Fl_Help_Dialog.H>

extern char* docdir;


Fl_Double_Window *aw = (Fl_Double_Window *) 0;
Fl_Help_Dialog *rw = (Fl_Help_Dialog *) 0;

Fl_Window *about()
{
  if (!aw) {
    aw = new Fl_Double_Window(Fl::w() / 2 - 200, Fl::h() / 2 - 150, 300, 150, _("About flMan'o'waR") );
    Fl_Box *bx = new Fl_Box(10, 10, 280, 50, _("flMan'O'waR\nClassic Battle Ship Game\n") );
    static char verstr[1024];
    sprintf(verstr,cpr);
    Fl_Box *bx_c = new Fl_Box(10, 85, 280, 40,verstr);
    Fl_Return_Button *ok_but = new Fl_Return_Button(60, 130, 180, 20, _("Ok"));
    ok_but->callback(cb_ok_but);
    aw->add(ok_but);
    aw->set_modal();
  }
  return (Fl_Window *) aw;
}

void rules()
{
    char fname[1024];
    strcpy(fname,docdir);
    char* loc=setlocale(LC_ALL,NULL);
    if(strstr(loc,"ru") || strstr(loc,"Ru"))
      strcat(fname,"/index_ru.html");
    else 
      strcat(fname,"/index.html");
    if (!rw) {
      rw = new Fl_Help_Dialog();
    }
    rw->load(fname);
    rw->show();
/*  if (!rw) {
    rw = new Fl_Double_Window(Fl::w() / 2 - 200, Fl::h() / 2 - 150, 400, 320, "Rules flMan'o'waR");
    Fl_Box *bx = new Fl_Box(10, 10, 380, 230, "flMan'O'waR\n"
                            "Place Your ships by left mouse button at the\n"
                            "left desk, You have got next 10 ships:      \n"
                            "- 1 four square                  \n"
                            "- 2 three square                 \n"
                            "- 3 two square                   \n"
                            "- 4 one square                   \n"
                            "Right click change orientation of placement. \n"
                            "When you've finished ships placement - The Fight\n"
                            "begin. Click enemy field and destroy all\n" "enemy ships. If the shoot was successful you \n" "continue to shoot, otherwise enemy begin to shoot.\n" "Player that destroy all ships win.           \n");
    Fl_Box *bx_c = new Fl_Box(10, 240, 380, 40, cpr);
    Fl_Return_Button *ok_but = new Fl_Return_Button(110, 295, 180, 20, "Ok");
    ok_but->callback(cb_ok_but);
    rw->add(ok_but);
    rw->set_modal();
  }
  return (Fl_Window *) rw;*/
}
